function bunnyhop_select(x)
{
  if (x<0) {
    if (x>this.min_x) {
      if (x>this.cos_middle.min_x)
        return this.cos_middle;
      if (x<this.cos_left.max_x)
        return this.cos_left;
      return this.line_left;
    }
  } else {
    if (x<this.max_x) {
      if (x<this.cos_middle.max_x)
        return this.cos_middle;
      if (x>this.cos_right.min_x)
        return this.cos_right;
      return this.line_right;
    }
  }
  return this.line_ground;
}

function bunnyhop_f(x)
{
  var element=this.select(x+this.xplus);
  return element.f(x+this.xplus)+this.yplus;
}

function bunnyhop_f_(x)
{
  var element=this.select(x+this.xplus);
  return element.f_(x+this.xplus);
}

function bunnyhop_f__(x)
{
  var element=this.select(x+this.xplus);
  return element.f__(x+this.xplus);
}

function bunnyhop_dl(x)
{
  var element=this.select(x+this.xplus);
  return element.dl(x+this.xplus);
}

function bunnyhop_values(x,values)
{
  if (!values) {
    values=new Object();
  }
  values.x=x;
  values.element=this.select(x+this.xplus);
  values.f=values.element.f(x+this.xplus)+this.yplus;
  values.f_=values.element.f_(x+this.xplus);
  values.f__=values.element.f__(x+this.xplus);
  values.dl=values.element.dl(x+this.xplus);
  return values;
}

function Bunnyhop(speed,slope,gravity,acceleration,deceleration,t_l,xplus,yplus)
{
  this.speed=speed;
  this.slope=slope;
  this.gravity=gravity;
  this.acceleration=acceleration;
  this.deceleration=deceleration;
  this.t_l=t_l;
  this.xplus=xplus;
  this.yplus=yplus;
  this.mspeed=speed;

  this.line_ground=new Line(0,0);

  this.line_left=new Line(this.slope,0);
  this.line_right=new Line(-this.slope,0);

  this.cos_middle=new FitCosinus(this.slope,-this.slope,this.deceleration/(this.mspeed*this.mspeed));
  for (var i=0;i<20;i++) // Iteration der Gipfelgeschwindigkeit und der Gipfelhoehe
  {
    this.mspeed=Math.sqrt(((this.speed*this.speed)*0.5-this.cos_middle.f(0)*this.gravity)*2.0);
    this.cos_middle.fit(this.slope,-this.slope,this.deceleration/(this.mspeed*this.mspeed));
  }
  this.cos_middle.min_x=-0.25*this.cos_middle.wavelen;
  this.cos_middle.max_x=0.25*this.cos_middle.wavelen;

  this.cos_left=new FitCosinus(0,this.slope,this.acceleration/(this.speed*this.speed));
  this.cos_left.yplus=-this.cos_left.f(-0.25*this.cos_left.wavelen);
  this.cos_left.max_x=this.cos_middle.min_x-this.t_l*this.speed/this.line_left.dl(0);
  this.cos_left.min_x=this.cos_left.max_x-0.5*this.cos_left.wavelen;
  this.cos_left.xplus=-0.5*(this.cos_left.min_x+this.cos_left.max_x);

  this.cos_right=new FitCosinus(-this.slope,0,this.acceleration/(this.speed*this.speed));
  this.cos_right.yplus=-this.cos_right.f(0.25*this.cos_right.wavelen);
  this.cos_right.min_x=this.cos_middle.max_x+this.t_l*this.speed/this.line_right.dl(0);
  this.cos_right.max_x=this.cos_right.min_x+0.5*this.cos_right.wavelen;
  this.cos_right.xplus=-0.5*(this.cos_right.max_x+this.cos_right.min_x);

  this.cos_middle.yplus=this.cos_left.f(this.cos_left.max_x)+this.slope*(this.cos_middle.min_x-this.cos_left.max_x);

  this.line_left.min_x=this.cos_left.max_x;
  this.line_left.max_x=this.cos_middle.min_x;
  this.line_left.yplus=this.cos_middle.f(this.cos_middle.min_x)-this.line_left.f(this.cos_middle.min_x);

  this.line_right.max_x=this.cos_right.min_x;
  this.line_right.min_x=this.cos_middle.max_x;
  this.line_right.yplus=this.cos_middle.f(this.cos_middle.max_x)-this.line_right.f(this.cos_middle.max_x);

  this.line_ground.upper=this;
  this.cos_left.upper=this;
  this.line_left.upper=this;
  this.cos_middle.upper=this;
  this.line_right.upper=this;
  this.cos_right.upper=this;

  this.min_x=this.cos_left.min_x;
  this.max_x=this.cos_right.max_x;
  if (!this.f)
  {
    this.select=bunnyhop_select;
    this.f=bunnyhop_f;
    this.f_=bunnyhop_f_;
    this.f__=bunnyhop_f__;
    this.dl=bunnyhop_dl;
    this.values=bunnyhop_values;
  }
}
